include:
  - project: 'numbereight/operations/ci-scripts'
    file: '/ios/ci.yml'

stages:
  - prepare
  - fetch
  - build
  - update
  - lint
  - deploy

variables:
  GIT_DEPTH: 1
  AUDIENCES_PODSPEC: NumberEightAudiencesBeta.podspec

#
# Gets the job ID from the upstream pipeline.  See `Update Version` job for more information.
#
Get Zip Audiences Job ID:
  extends: .base-get-job-id-ios
  stage: prepare
  variables:
    NESDKIOS_DEPENDENT_JOB_NAME: "Zip Audiences Source"

#
# Downloads the artifacts from the upstream pipeline for the particular job ID.
# This will make them available as artifacts to downstream jobs of this pipeline.
#
Get Artifacts Audiences:
  extends: .base-get-job-artifacts-ios
  stage: fetch
  needs:
    - job: Get Zip Audiences Job ID
      artifacts: true
      optional: true
  artifacts:
    paths:
      - Audiences.zip

#
# Pushes the new built artifacts to the repo for deploy, and updates the podspec with the appropriate version.
#
# Usage:
#  - NESDKIOS_VERSION: the new version of the iOS SDK .e.g 3.1.4
#  - NESDKIOS_UPSTREAM_PIPELINE: The pipeline ID for the iOS SDK pipeline to pull artifacts from.  Note the jobs must have succeeded.
#
Update Version:
  extends: .base-update-repo
  stage: update
  rules:
    - if: $CI_PIPELINE_SOURCE == "pipeline" && $NESDKIOS_VERSION != null && $NESDKIOS_VERSION != "" 
    - if: $CI_PIPELINE_SOURCE == "web" && $NESDKIOS_VERSION != "" && $NESDKIOS_VERSION == null
    - if: $NESDKIOS_VERSION != null && $NESDKIOS_VERSION != "" && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  needs:
    - job: Get Artifacts Audiences
      artifacts: true
      optional: true
  variables:
    UPSTREAM_PROJECT_ID: $NESDKIOS_PROJECT_ID
    UPDATE_VERSION: $NESDKIOS_VERSION
  script:
    - rm -rf Source
    - unzip -o Audiences.zip
    - rm Audiences.zip
    - version="$(cut -d '-' -f 1 <<< ${NESDKIOS_VERSION:1})"
    - sed -i -e "s/  spec.version = '.*'/  spec.version = '${version}'/" "$AUDIENCES_PODSPEC"
    - git add .
    - !reference [.push-to-git, script]

#
# Lints the CocoaPod before we do the release.  This is idempotent.
#
Lint Audiences:
  extends: .baseLintCocoapod
  stage: lint
  variables:
    PODSPEC: $AUDIENCES_PODSPEC

#
# Pushes Audiences to the numbereight CocoaPods repo.
# Don't push to trunk, this is the beta build.
#
Push Audiences:
  extends: .basePushToCocoapods
  stage: deploy
  variables:
    DESTINATION: "numbereight"
    PODSPEC: $AUDIENCES_PODSPEC
